package it.micegroup.gestioneferie.pianificazioneferie.entity;

import java.io.Serializable;

import javax.validation.constraints.NotNull;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import java.util.Collection;
import java.util.ArrayList;
import javax.persistence.OneToMany;
import javax.persistence.CascadeType;
import com.fasterxml.jackson.annotation.JsonManagedReference;
import lombok.ToString;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;

import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.Getter;
import lombok.AllArgsConstructor;

import javax.persistence.Table;

import org.apache.commons.lang3.StringUtils;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.hibernate.Hibernate;
import java.util.Objects;

import it.micegroup.gestioneferie.libs.entity.BaseEntity;
import it.micegroup.voila2runtime.utils.EntityUtils;

@NoArgsConstructor

@Getter
@Setter
@Entity
@Table(name = "D_STATI_RICH_ADESIONE_PF")
public class DstatiRichAdesionePf extends BaseEntity implements Serializable {

	// Generated SERIAL VERSION UID
	private static final long serialVersionUID = 3373397213L;

	@SuppressWarnings("unused")
	private static final Logger LOGGER = LogManager.getLogger(DstatiRichAdesionePf.class);

	// ATTRIBUTES
	@NotNull

	@Column(name = "SEQU_ID_STATO_RICH_ADESIONE_PF", columnDefinition = "NUMBER(15)")
	private Long sequIdStatoRichAdesionePf;
	@NotNull

	@Column(name = "CODI_STATO_RICHIESTA_ADES", columnDefinition = "VARCHAR(50)")
	private String codiStatoRichiestaAdes;
	@NotNull

	@Column(name = "DESC_STATO_RICHIESTA_ADES", columnDefinition = "VARCHAR(250)")
	private String descStatoRichiestaAdes;
	@NotNull

	@Column(name = "FLAG_ELIMINATO", columnDefinition = "VARCHAR(1)")
	private String flagEliminato;
	@NotNull

	@Column(name = "UTENTE_ULTIMA_MODIFICA", columnDefinition = "VARCHAR(50)")
	private String utenteUltimaModifica;
	@NotNull

	@Column(name = "DATA_ULTIMA_MODIFICA", columnDefinition = "DATE")
	private Date dataUltimaModifica;
	@NotNull

	@Column(name = "DATA_INIZIO_RECORD", columnDefinition = "DATE")
	private Date dataInizioRecord;
	@NotNull

	@Column(name = "DATA_FINE_RECORD", columnDefinition = "DATE")
	private Date dataFineRecord;

	// IMPORTED PARENTS

	// CONSTRUCTORS
	public DstatiRichAdesionePf(String objectKey) {
		super();
		setObjectKey(objectKey);
	}

	public DstatiRichAdesionePf(DstatiRichAdesionePfKey dstatiRichAdesionePfKey, Long sequIdStatoRichAdesionePf,
			String codiStatoRichiestaAdes, String descStatoRichiestaAdes, String flagEliminato,
			String utenteUltimaModifica, Date dataUltimaModifica, Date dataInizioRecord, Date dataFineRecord) {
		super();

		this.dstatiRichAdesionePfKey = dstatiRichAdesionePfKey;

		this.sequIdStatoRichAdesionePf = sequIdStatoRichAdesionePf;
		this.codiStatoRichiestaAdes = codiStatoRichiestaAdes;
		this.descStatoRichiestaAdes = descStatoRichiestaAdes;
		this.flagEliminato = flagEliminato;
		this.utenteUltimaModifica = utenteUltimaModifica;
		this.dataUltimaModifica = dataUltimaModifica;
		this.dataInizioRecord = dataInizioRecord;
		this.dataFineRecord = dataFineRecord;
	}

	// CHILDREN
	@JsonProperty(access = Access.WRITE_ONLY)
	@JsonManagedReference("theDstatiRichAdesionePf")
	@OneToMany(mappedBy = "theDstatiRichAdesionePf", fetch = FetchType.LAZY, cascade = CascadeType.ALL)
	@ToString.Exclude
	private Collection<DrichAdesionePf> theDrichAdesionePf = new ArrayList<>();

	// PARENTS

	// GETTER/SETTER
	/**
	 * @return the sequIdStatoRichAdesionePf
	 */
	public Long getSequIdStatoRichAdesionePf() {
		return this.sequIdStatoRichAdesionePf;
	}

	/**
	 * @param sequIdStatoRichAdesionePf to set
	 */
	public void setSequIdStatoRichAdesionePf(Long sequIdStatoRichAdesionePf) {
		this.sequIdStatoRichAdesionePf = sequIdStatoRichAdesionePf;
	}

	/**
	 * @return the codiStatoRichiestaAdes
	 */
	public String getCodiStatoRichiestaAdes() {
		return this.codiStatoRichiestaAdes;
	}

	/**
	 * @param codiStatoRichiestaAdes to set
	 */
	public void setCodiStatoRichiestaAdes(String codiStatoRichiestaAdes) {
		this.codiStatoRichiestaAdes = codiStatoRichiestaAdes;
	}

	/**
	 * @return the descStatoRichiestaAdes
	 */
	public String getDescStatoRichiestaAdes() {
		return this.descStatoRichiestaAdes;
	}

	/**
	 * @param descStatoRichiestaAdes to set
	 */
	public void setDescStatoRichiestaAdes(String descStatoRichiestaAdes) {
		this.descStatoRichiestaAdes = descStatoRichiestaAdes;
	}

	/**
	 * @return the flagEliminato
	 */
	public String getFlagEliminato() {
		return this.flagEliminato;
	}

	/**
	 * @param flagEliminato to set
	 */
	public void setFlagEliminato(String flagEliminato) {
		this.flagEliminato = flagEliminato;
	}

	/**
	 * @return the utenteUltimaModifica
	 */
	public String getUtenteUltimaModifica() {
		return this.utenteUltimaModifica;
	}

	/**
	 * @param utenteUltimaModifica to set
	 */
	public void setUtenteUltimaModifica(String utenteUltimaModifica) {
		this.utenteUltimaModifica = utenteUltimaModifica;
	}

	/**
	 * @return the dataUltimaModifica
	 */
	public Date getDataUltimaModifica() {
		return this.dataUltimaModifica;
	}

	/**
	 * @param dataUltimaModifica to set
	 */
	public void setDataUltimaModifica(Date dataUltimaModifica) {
		this.dataUltimaModifica = dataUltimaModifica;
	}

	/**
	 * @return the dataInizioRecord
	 */
	public Date getDataInizioRecord() {
		return this.dataInizioRecord;
	}

	/**
	 * @param dataInizioRecord to set
	 */
	public void setDataInizioRecord(Date dataInizioRecord) {
		this.dataInizioRecord = dataInizioRecord;
	}

	/**
	 * @return the dataFineRecord
	 */
	public Date getDataFineRecord() {
		return this.dataFineRecord;
	}

	/**
	 * @param dataFineRecord to set
	 */
	public void setDataFineRecord(Date dataFineRecord) {
		this.dataFineRecord = dataFineRecord;
	}

	// CHILD GETTER/SETTER
	/**
	 * @return the DrichAdesionePf
	 */
	public Collection<DrichAdesionePf> getTheDrichAdesionePf() {
		return theDrichAdesionePf;
	}

	/**
	 * @param aDrichAdesionePfList to set
	 */
	public void setTheDrichAdesionePf(Collection<DrichAdesionePf> aDrichAdesionePfList) {
		theDrichAdesionePf = aDrichAdesionePfList;
	}

	/// ADD CHILD
	public void addDrichAdesionePf(DrichAdesionePf drichAdesionePf) {
		theDrichAdesionePf.add(drichAdesionePf);
	}

	// PARENT GETTER/SETTER

	// PARENT ID GETTER/SETTER

	// PARENT OBJECT TITLE

	// PARENT OBJECT KEY

	// IMPORTED PARENT OBJECT KEY

	// OPERATIONS

	// OBJECT KEY
	/**
	 * Restituisce l'identificativo della chiave in formato stringa. Ritorna
	 * conveniente nelle selezioni da lista.
	 * 
	 * @return L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public String getObjectKey() {
		return getObjectKeyById(getDstatiRichAdesionePfKey());
	}

	public String getObjectKeyById(DstatiRichAdesionePfKey identification) {
		if (identification == null) {
			return null;
		}
		StringBuilder output = new StringBuilder();
		return output.toString();
	}

	/**
	 * Inizializza la parte identificativa del bean in base alla stringa tokenizzata
	 * da "||" fornita in input.
	 * 
	 * @param key L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public void setObjectKey(String key) {
		if (key == null || key.trim().length() == 0) {
			return;
		}
		String[] array = StringUtils.splitByWholeSeparatorPreserveAllTokens(key, getRowIdFieldDelimiter());
		int ctr = 0;

		dstatiRichAdesionePfKey = new DstatiRichAdesionePfKey();
	}

	// OBJECT TITLE
	public String getObjectTitle() {
		StringBuilder output = new StringBuilder();
		output.append(getCodiStatoRichiestaAdes());
		return output.toString();
	}

	// COMPOSITE PRIMARY KEY
	@EmbeddedId
	private DstatiRichAdesionePfKey dstatiRichAdesionePfKey;

	// GETTER/SETTER CK
	/**
	 * @return the dstatiRichAdesionePfKey
	 */
	public DstatiRichAdesionePfKey getDstatiRichAdesionePfKey() {
		return this.dstatiRichAdesionePfKey;
	}

	/**
	 * @param dstatiRichAdesionePfKey to set
	 */
	public void setDstatiRichAdesionePfKey(DstatiRichAdesionePfKey dstatiRichAdesionePfKey) {
		this.dstatiRichAdesionePfKey = dstatiRichAdesionePfKey;
	}

	// COMPOSITE KEY CLASS

	// PREPERSIST
	public void syncCK() {
		if (dstatiRichAdesionePfKey == null) {
			dstatiRichAdesionePfKey = new DstatiRichAdesionePfKey();
		}
	}

	@PrePersist
	public void prePersist() {
		syncCK();
	}

	@PreUpdate
	public void PreUpdate() {
		syncCK();
	}

	// Equals / HashCode
	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o))
			return false;
		DstatiRichAdesionePf that = (DstatiRichAdesionePf) o;
		return dstatiRichAdesionePfKey != null && Objects.equals(dstatiRichAdesionePfKey, that.dstatiRichAdesionePfKey);
	}

	@Override
	public int hashCode() {
		return Objects.hash(dstatiRichAdesionePfKey);
	}
}
